/*
 * Exemplo de uso de memria "compartilhada".
 * Criao de um segmento em um nico processo e verificao de endereos.
 */ 
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <stdio.h>
#include <stdlib.h>

#define SHMSZ 27 /* Ser arredondado para um mltiplo de PAGE_SIZE */

char str_global[10];

int main() {
  int shmid;
  key_t key;
  char str_local[10];
  char *shm;
  
  /* Chave arbitrria para o segmento compartilhado */
  key = 5677;

  /* Criao do segmento de memria e obteno do seu identificador. */
  if ((shmid = shmget(key, SHMSZ, IPC_CREAT | 0666)) < 0) {
    perror("shmget");
    exit(1);
  }

  /* Segmento  associado ao espao de endereamento */
  if ((shm = shmat(shmid, NULL, 0)) == (char *) -1) {
    perror("shmat");
    exit(1);
  }

  printf("str_local  = 0x%x\n", (unsigned int) str_local);
  printf("shm        = 0x%x\n", (unsigned int) shm);  
  printf("str_global = 0x%x\n", (unsigned int) str_global);
  printf("main       = 0x%x\n", (unsigned int) main);




  return 0;
}
